\appendix
\section{Stückliste} \label{kap:Stueckliste}
\includegraphics[scale=0.9,pages=-]{Abbildungen/BSS_Stueckliste_PNG.PNG} 
\newpage
%\section{Technische Zeichungen des Gehäuses}
\includepdf[fitpaper, pagecommand={\section{Technische Zeichungen des Gehäuses}\subsection{Akkukasten \label{AkkukastenZeichnung}}}, scale=.7, angle=90]{Abbildungen/BSS_Akkukasten_Technische_Zeichnung.pdf}
\includepdf[fitpaper, pagecommand={\subsection{Elektronikkasten \label{ElektronikkastenZeichnung}}}, scale=.7, angle=90]{Abbildungen/BSS_Elektronikkasten_Technische_Zeichnung.pdf}
\includepdf[fitpaper, pagecommand={\subsection{Deckel \label{DeckelZeichnung}}}, scale=.7, angle=90]{Abbildungen/BSS_Deckel_Technische_Zeichnung.pdf}
\includepdf[fitpaper, pagecommand={\subsection{Dichtung Akkukasten \label{DichtungAkkukastenZeichnung}}}, scale=.7, angle=90]{Abbildungen/BSS_Dichtung_Akkukasten_Technische_Zeichnung.pdf}
\includepdf[fitpaper, pagecommand={\subsection{Dichtung Elektronikkasten \label{DichtungElektronikkastenZeichnung}}}, scale=.7, angle=90]{Abbildungen/BSS_Dichtung_Elektronikkasten_Technische_Zeichnung.pdf}
\includepdf[fitpaper, pagecommand={\subsection{Explosionszeichnung mit Stückliste \label{Explosionszeichnung}}}, scale=.75, angle=90]{Abbildungen/BSS_Explosion.pdf}

\newpage
\section{Nodes} \label{kap:Nodes}
\subsection{BSS core nodes} \label{BSScore}
\subsubsection{writer.py} \label{BSSwriter}
\begin{lstlisting}[language=Python, caption=writer.py Node]
##
# HAW Hamburg WiSe 2022/23
#
# Fahrrad-Datenlogger Projekt im Studienfach BMT6 Sensorik - Gruppe 5
# bei Prof. Dr. Rasmus Rettig
#
# Erstellt durch:
# Helmer Luis Barcos Paso
##

import os
import csv
import uuid
import rospy

from datetime import datetime
from dataclasses import dataclass
from bssmessage.msg import BSSIMUPayload, BSSUSSPayload, BSSGNSSPayload, BSSACCPayload


nodeName = "bsscorewriter"
printNodeName = "[{}]".format(nodeName)

# Note the RasperryOS for the Raspberry Pi 4 Model B @ 2018
# uses ext4 for the main Partition.
# Run sudo lsblk -o NAME,FSTYPE,SIZE,MOUNTPOINT for more info
#
# The use of ext4 means that the max. number of files is 4 billion
# This property is tracked globally and not in each directory.
# The number of subdirectories is unlimited while the

# Write in folder ${project_root}/data
# Write imu to ${project_root}/data/imu/ddmmyy-[count].csv
# Write uss to ${project_root}/data/uss/ddmmyy-[count].csv
# Write gnss to ${project_root}/data/gnss/ddmmyy-[count].csv


class Writer:
    startTime = None
    basepath = ""
    completeFolder = ""
    header = None

    def __init__(self, folderName: str, header) -> None:
        self.basepath = os.environ.get("WRITER_PATH", "/root/catkin_ws/data")
        self.startTime = datetime.now()
        self.header = header
        self.config(folderName)
        pass

    def config(self, folderName: str):
        self.createFolder(folderName)

    def createFolder(self, folderName: str):
        self.completeFolder = self.basepath + "/" + folderName
        exists = os.path.exists(self.completeFolder)
        if not exists:
            os.makedirs(self.completeFolder)
            rospy.loginfo("{} Writer folder {} created successfully".format(
                printNodeName, self.completeFolder))

    def write(self, payload):
        fileName = self.getFileName()
        if self.shouldChangeFile() or not os.path.exists(fileName):
            self.ensureHeader()

        with open(fileName, "a", encoding="UTF8") as someFile:
            someWriter = csv.DictWriter(someFile, fieldnames=self.header)
            someWriter.writerow(payload)

    def ensureHeader(self):
        fileName = self.getFileName()
        with open(fileName, "w", encoding="UTF8") as someFile:
            someWriter = csv.DictWriter(someFile, fieldnames=self.header)
            someWriter.writeheader()

    def getFileName(self):
        year = self.startTime.year
        month = self.startTime.month
        day = self.startTime.day
        fileName = '{:02d}{:02d}{:02d}.csv'.format(year, month, day)
        return "{}/{}".format(self.completeFolder, fileName)

    def shouldChangeFile(self) -> bool:
        if datetime.now().day != self.startTime.day:
            self.startTime = datetime.now()
            return True

        return False


class Sensor:
    writer = None
    topicName: str = ""
    msgClass = None

    def __init__(self, type: str, msgClass, header) -> None:
        self.writer = Writer(type, header)
        self.msgClass = msgClass
        self.topicName = "bssdata/" + type
        pass

    @staticmethod
    def getBaseProps(payload):
        return payload.id, payload.timestamp


class IMUSensor(Sensor):
    def __init__(self) -> None:
        super().__init__(type="imu", msgClass=BSSIMUPayload, header=["id", "timestamp",
                                                                     "pressure", "temperature", "altitude",
                                                                     "Wx", "Wy", "Wz",
                                                                     "Mx", "My", "Mz",
                                                                     "Ax", "Ay", "Az"])

    def cb(self, payload: BSSIMUPayload):
        id, timestamp = super().getBaseProps(payload)

        # Pressure (Pa), Temp (°C) and altitude (m)
        pressure = payload.pressure
        temperature = payload.temperature
        altitude = payload.altitude

        # GyroscopeData in rad/s
        Wx = payload.Wx
        Wy = payload.Wy
        Wz = payload.Wz

        # MagnetometerData in uT (micro Tesla)
        Mx = payload.Mx
        My = payload.My
        Mz = payload.Mz

        # AccelerometerData in m/s^2
        Ax = payload.Ax
        Ay = payload.Ay
        Az = payload.Az

        self.writer.write(
            payload={"id": id, "timestamp": timestamp,
                     "pressure": pressure, "temperature": temperature, "altitude": altitude,
                     "Wx": Wx, "Wy": Wy, "Wz": Wz,
                     "Mx": Mx, "My": My, "Mz": Mz,
                     "Ax": Ax, "Ay": Ay, "Az": Az
                     })
        rospy.loginfo(
            "{} BSSIMUPayload written id={}".format(printNodeName, id))

class ACCSensor(Sensor):
    def __init__(self) -> None:
        super().__init__(type="acc", msgClass=BSSACCPayload, header=["id", "timestamp",
                                                                     "Ax", "Ay", "Az"])

    def cb(self, payload: BSSACCPayload):
        id, timestamp = super().getBaseProps(payload)

        # AccelerometerData in m/s^2
        Ax = payload.Ax
        Ay = payload.Ay
        Az = payload.Az

        self.writer.write(
            payload={"id": id, "timestamp": timestamp,
                     "Ax": Ax, "Ay": Ay, "Az": Az
                     })
        rospy.loginfo(
            "{} BSSACCPayload written id={}".format(printNodeName, id))

class USSSensor(Sensor):
    def __init__(self) -> None:
        super().__init__(type="uss", msgClass=BSSUSSPayload,
                         header=["id", "timestamp", "distance1", "distance2"])

    def cb(self, payload: BSSUSSPayload):
        id, timestamp = super().getBaseProps(payload)
        distance1 = payload.distance1
        distance2 = payload.distance2
        self.writer.write(
            payload={"id": id, "timestamp": timestamp, "distance1": distance1, "distance2": distance2})
        rospy.loginfo(
            "{} BSSUSSPayload written id={}".format(printNodeName, id))


class GNSSSensor(Sensor):
    def __init__(self) -> None:
        super().__init__(type="gnss", msgClass=BSSGNSSPayload, header=[
            "id", "timestamp", "hasValue", "latitude", "longitude", "speed", "course"])

    def cb(self, payload: BSSGNSSPayload):
        id, timestamp = super().getBaseProps(payload)
        hasValue = payload.hasValue
        latitude = payload.latitude
        longitude = payload.longitude
        speed = payload.speed
        course = payload.course
        self.writer.write(
            payload={"id": id, "timestamp": timestamp, "hasValue": hasValue, "latitude": latitude, "longitude": longitude, "speed": speed, "course": course})
        rospy.loginfo(
            "{} BSSGNSSPayload written id={}".format(printNodeName, id))


def writterNode():
    rospy.init_node(nodeName, anonymous=False)
    rospy.loginfo("{} Did start successfully".format(printNodeName))

    sensoren = [ACCSensor(), IMUSensor(), USSSensor(), GNSSSensor()]

    for sensor in sensoren:
        rospy.Subscriber(sensor.topicName, sensor.msgClass, sensor.cb)

    # spin() simply keeps python from exiting until this node is stopped
    rospy.spin()


if __name__ == '__main__':
    try:
        writterNode()
    except rospy.ROSInterruptException:
        pass

\end{lstlisting}
\subsubsection{i2c.py} \label{BSSi2c}
\begin{lstlisting}[language=Python, caption=i2c.py Node]
##
# HAW Hamburg WiSe 2022/23
#
# Fahrrad-Datenlogger Projekt im Studienfach BMT6 Sensorik - Gruppe 5
# bei Prof. Dr. Rasmus Rettig
#
# Erstellt durch:
# Helmer Luis Barcos Paso
##

import uuid
import rospy

from bssmessage.msg import BSSI2CState

nodeName = "bsscorei2c"
printNodeName = "[{}]".format(nodeName)
topicName = "bsscore/i2c"


def isI2CBusActive() -> bool:
    # rospy.logwarn(
    #     "{} BSSI2CState isI2CBusActive needs to be implemented".format(printNodeName))
    return True


def getI2CDeviceCount() -> int:
    # rospy.logwarn(
    #     "{} BSSI2CState getI2CDeviceCount needs to be implemented".format(printNodeName))
    return 8


def mainNode():
    pub = rospy.Publisher(topicName, BSSI2CState, queue_size=10)
    rospy.init_node(nodeName, anonymous=True)
    rospy.loginfo("{} Did start successfully".format(printNodeName))

    # publishes at a rate of 1 message per second
    rate = rospy.Rate(1)  # 1hz

    while not rospy.is_shutdown():
        msg = BSSI2CState()

        msg.id = uuid.uuid4().hex
        msg.timestamp = rospy.get_rostime()
        msg.isBusActive = isI2CBusActive()
        msg.deviceCount = getI2CDeviceCount()

        rospy.loginfo("{} BSSI2CState will be published".format(printNodeName))
        rospy.loginfo("{} BSSI2CState id={} time={} isBusActive={} deviceCount={}".format(
            printNodeName, msg.id, msg.timestamp, msg.isBusActive, msg.deviceCount))
        rospy.loginfo(
            "{} BSSI2CState id={} published successfully\n".format(printNodeName, msg.id))

        pub.publish(msg)
        rate.sleep()


if __name__ == '__main__':
    try:
        mainNode()
    except rospy.ROSInterruptException:
        pass

\end{lstlisting}

\subsubsection{net.py} \label{BSSnet}
\begin{lstlisting}[language=Python, caption=net.py Node]
##
# HAW Hamburg WiSe 2022/23
#
# Fahrrad-Datenlogger Projekt im Studienfach BMT6 Sensorik - Gruppe 5
# bei Prof. Dr. Rasmus Rettig
#
# Erstellt durch:
# Helmer Luis Barcos Paso
##
import uuid
import socket
import rospy

from bssmessage.msg import BSSNetConn

nodeName = "bsscorenet"
printNodeName = "[{}]".format(nodeName)
topicName = "bsscore/net"

# Snapshot from https://github.com/mfoc/monitor-internet-connection
# The project was published under the MIT License


def is_internet_alive(host="8.8.8.8", port=53, timeout=3) -> bool:
    """Check if Internet Connection is alive and external IP address is reachable.
    Input Parameters:
        host: (string) 8.8.8.8 (google-public-dns-a.google.com)
        port: (integer) (53/tcp DNS Service).
        timeout: (float) timeout in seconds.
    Returns:
        True (Boolean) if external IP address is reachable.
        False (Boolean) if external IP address is unreachable.
    """

    try:
        socket.setdefaulttimeout(timeout)
        s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        s.connect((host, port))
    except OSError as error:
        rospy.logdebug("{} BSSNetConn error: ".format(
            printNodeName, error.strerror))
        return False
    else:
        s.close()
        return True


def mainNode():
    pub = rospy.Publisher(topicName, BSSNetConn, queue_size=10)
    rospy.init_node(nodeName, anonymous=True)
    rospy.loginfo("{} Did start successfully".format(printNodeName))

    # publishes at a rate of 1 message per second
    rate = rospy.Rate(1)  # 1hz

    while not rospy.is_shutdown():
        msg = BSSNetConn()

        msg.id = uuid.uuid4().hex
        msg.timestamp = rospy.get_rostime()
        msg.isConnected = is_internet_alive()

        rospy.loginfo("{} BSSNetConn will be published".format(printNodeName))
        rospy.loginfo("{} BSSNetConn id={} time={} isConnected={}".format(
            printNodeName, msg.id, msg.timestamp, msg.isConnected))
        rospy.loginfo(
            "{} BSSNetConn id={} published successfully\n".format(printNodeName, msg.id))

        pub.publish(msg)
        rate.sleep()


if __name__ == '__main__':
    try:
        mainNode()
    except rospy.ROSInterruptException:
        pass
\end{lstlisting}

\subsection{BSS sensors nodes} \label{BSSsensors}
\subsubsection{gnss.py} \label{BSSgnss}
\begin{lstlisting}[language=Python, caption=gnss.py Node]
##
# HAW Hamburg WiSe 2022/23
#
# Fahrrad-Datenlogger Projekt im Studienfach BMT6 Sensorik - Gruppe 5
# bei Prof. Dr. Rasmus Rettig
#
# Erstellt durch:
# Van Uoc Phung
##

import uuid
import rospy

from random import uniform
from bssmessage.msg import BSSGNSSPayload
from src.Venus638FLPx import GPS, Point


nodeName = "bsssensorsgnss"
printNodeName = "[{}]".format(nodeName)
topicName = "bssdata/gnss"


def callback(pub, point: Point, speed: float, course: float):
    msg = BSSGNSSPayload()

    msg.id = uuid.uuid4().hex
    msg.timestamp = rospy.get_rostime()
    msg.hasValue = point.hasValue
    msg.latitude = point.latitude
    msg.longitude = point.longitude
    msg.speed = speed
    msg.course = course

    rospy.loginfo(
        "{} BSSGNSSPayload will be published to {}".format(printNodeName, topicName))
    rospy.loginfo("{} BSSGNSSPayload id={} time={} latitude={} longitude={} speed={} hasValue={}".format(
        printNodeName, msg.id, msg.timestamp, msg.latitude, msg.longitude, speed, msg.hasValue))

    pub.publish(msg)
    rospy.loginfo(
        "{} BSSGNSSPayload id={} published successfully\n".format(printNodeName, msg.id))


def mainNode():
    # use a bigger queue_size than the rospy.Rate in order to prevent data loss
    pub = rospy.Publisher(topicName, BSSGNSSPayload, queue_size=10)
    rospy.init_node(nodeName, anonymous=True)
    rospy.loginfo("{} Did start successfully".format(printNodeName))

    gps = GPS(pub, printNodeName)
    gps.subscribe(callback)

    while not rospy.is_shutdown():
        try:
            gps.trackPosition()
        except KeyboardInterrupt:
            pass
        except Exception as e:
            rospy.logerr("{} Exception :: {}".format(printNodeName, e))
            continue


if __name__ == '__main__':
    try:
        mainNode()
    except rospy.ROSInterruptException:
        pass

# Dont forget to give execution rights -> chmod +x publisher.py
# Execurte by running -> python3 publisher.py
# Listen the Topic by running rostopic echo /bssexample/data in Terminal
# Better ->> Start with rosrun -> rosrun bssexample publisher.py
\end{lstlisting}

\subsubsection{imu.py} \label{BSSimu}
\begin{lstlisting}[language=Python, caption=imu.py Node]
##
# HAW Hamburg WiSe 2022/23
#
# Fahrrad-Datenlogger Projekt im Studienfach BMT6 Sensorik - Gruppe 5
# bei Prof. Dr. Rasmus Rettig
#
# Erstellt durch:
# Helmer Luis Barcos Paso
##

import board
import uuid
import time
import rospy
import adafruit_l3gd20
import adafruit_lsm303_accel
import adafruit_lsm303dlh_mag
from typing import Union
from dataclasses import dataclass
import Adafruit_BMP.BMP085 as BMP085
from random import uniform
from bssmessage.msg import BSSIMUPayload
from adafruit_l3gd20 import L3DS20_RANGE_250DPS, L3DS20_RATE_100HZ
from adafruit_lsm303_accel import Mode, Range, Rate
from adafruit_lsm303dlh_mag import MAGRATE_3_0, MAGGAIN_1_3

@dataclass
class AccelerometerData:
    Ax: float = 0.0
    """ Beschleunigung in x in m/s^2 """
    Ay: float = 0.0
    """ Beschleunigung in y in m/s^2 """
    Az: float = 0.0
    """ Beschleunigung in z in m/s^2 """


@dataclass
class MagnetometerData:
    Mx: float = 0.0
    """ Magnetfeld in x in uT (micro Tesla) """
    My: float = 0.0
    """ Magnetfeld in y in uT (micro Tesla) """
    Mz: float = 0.0
    """ Magnetfeld in z in uT (micro Tesla) """


class Accelerometer:
    name = "LSM303"
    sensor = None
    didStart = False
    nodeName = ""

    def __init__(self, nodeName=""):
        self.nodeName = nodeName
        try:
            i2c = board.I2C()
            self.sensor = adafruit_lsm303_accel.LSM303_Accel(i2c)
            self.sensor.mode = Mode.MODE_HIGH_RESOLUTION
            # https://www.digikey.de/en/articles/what-you-need-to-know-to-choose-an-accelerometer
            self.sensor.range = Range.RANGE_8G
            self.sensor.data_rate = Rate.RATE_25_HZ
            self.didStart = True
        except Exception as err:
            self.didStart = False
            rospy.logerr('{} {} Exception: {}'.format(
                self.nodeName, self.name,  err))

    def didStart(self):
        return self.didStart

    def getData(self) -> Union[AccelerometerData, None]:
        if (self.didStart == False):
            rospy.logerr('{} {} I2C not configured'.format(
                self.nodeName, self.name))

        else:
            current = self.sensor.acceleration
            return AccelerometerData(current[0], current[1], current[2])


class Magnetometer:
    name = "LSM303DLH"
    sensor = None
    didStart = False
    nodeName = ""

    def __init__(self, nodeName=""):
        self.nodeName = nodeName
        try:
            i2c = board.I2C()
            self.sensor = adafruit_lsm303dlh_mag.LSM303DLH_Mag(i2c)
            self.sensor.mag_rate = MAGRATE_3_0  # 3Hz
            self.sensor.mag_gain = MAGGAIN_1_3
            self.didStart = True
        except Exception as err:
            self.didStart = False
            rospy.logerr('{} {} Exception: {}'.format(
                self.nodeName, self.name,  err))

    def didStart(self):
        return self.didStart

    def getData(self) -> Union[MagnetometerData, None]:
        if (self.didStart == False):
            rospy.logerr('{} {} I2C not configured'.format(
                self.nodeName, self.name))
        else:
            current = self.sensor.magnetic
            return MagnetometerData(current[0], current[1], current[2])


@dataclass
class PressureAndTemperatureData:
    pressure: float = 0.0
    """ Druck in Pa """
    temperature: int = 0
    """ Temperatur in °C """
    altitude: float = 0.0
    """ Hohe in m """


class PressureAndTemperature:
    name = "BMP180"
    sensor = None
    didStart = False
    nodeName = ""

    def __init__(self, nodeName=""):
        self.nodeName = nodeName
        try:
            self.sensor = BMP085.BMP085()
            self.didStart = True
        except Exception as err:
            self.didStart = False
            rospy.logerr('{} {} Exception: {}'.format(
                self.nodeName, self.name,  err))

    def didStart(self):
        return self.didStart

    def getData(self) -> Union[PressureAndTemperatureData, None]:
        if (self.didStart == False):
            rospy.logerr('{} {} I2C not configured'.format(
                self.nodeName, self.name))

        else:
            temperature = self.sensor.read_temperature()
            pressure = self.sensor.read_pressure()
            altitude = self.sensor.read_altitude()
            return PressureAndTemperatureData(pressure, temperature, altitude)

@dataclass
class GyroscopeData:
    Wx: float = 0.0
    """ Dreahrate in x in rad/s """
    Wy: float = 0.0
    """ Dreahrate in y in rad/s """
    Wz: float = 0.0
    """ Dreahrate in z in rad/s """


class Gyroscope:
    name = "L3DG20H"
    sensor = None
    didStart = False
    nodeName = ""

    def __init__(self, nodeName=""):
        self.nodeName = nodeName
        try:
            i2c = board.I2C()
            self.sensor = adafruit_l3gd20.L3GD20_I2C(
                i2c, rng=L3DS20_RANGE_250DPS, rate=L3DS20_RATE_100HZ)
            self.didStart = True
        except Exception as err:
            self.didStart = False
            rospy.logerr('{} {} Exception: {}'.format(
                self.nodeName, self.name,  err))

    def didStart(self):
        return self.didStart

    def getData(self) -> Union[GyroscopeData, None]:
        if (self.didStart == False):
            rospy.logerr('{} {} I2C not configured'.format(
                self.nodeName, self.name))
        else:
            current = self.sensor.gyro
            return GyroscopeData(current[0], current[1], current[2])


nodeName = "bsssensorsimu"
printNodeName = "[{}]".format(nodeName)
topicName = "bssdata/imu"

gyro = Gyroscope(nodeName=nodeName)
magno = Magnetometer(nodeName=nodeName)
accel = Accelerometer(nodeName=nodeName)
bmp = PressureAndTemperature(nodeName=nodeName)


def mainNode():
    # use a bigger queue_size than the rospy.Rate in order to prevent data loss
    pub = rospy.Publisher(topicName, BSSIMUPayload, queue_size=10)
    rospy.init_node(nodeName, anonymous=True)
    rospy.loginfo("{} Did start successfully".format(printNodeName))

    # publishes at a rate of 2 messages per second
    rate = rospy.Rate(2)  # 2hz

    while not rospy.is_shutdown():

        msg = BSSIMUPayload()

        msg.id = uuid.uuid4().hex
        msg.timestamp = rospy.get_rostime()
        mData = magno.getData()
        gData = gyro.getData()
        aData = accel.getData()
        bmpData = bmp.getData()

        if mData:
            msg.Mx = mData.Mx
            msg.My = mData.My
            msg.Mz = mData.Mz

        if gData:
            msg.Wx = gData.Wx
            msg.Wy = gData.Wy
            msg.Wz = gData.Wz

        if gData:
            msg.Ax = aData.Ax
            msg.Ay = aData.Ay
            msg.Az = aData.Az

        if bmpData:
            msg.altitude = bmpData.altitude
            msg.pressure = bmpData.pressure
            msg.temperature = bmpData.temperature

        rospy.loginfo(
            "{} BSSIMUPayload will be published".format(printNodeName))
        rospy.loginfo("{} BSSIMUPayload id={} time={}".format(
            printNodeName, msg.id, msg.timestamp))
        rospy.loginfo(
            "{} BSSIMUPayload id={} published successfully\n".format(printNodeName, msg.id))

        pub.publish(msg)
        rate.sleep()


if __name__ == '__main__':
    try:
        mainNode()
    except rospy.ROSInterruptException:
        pass
\end{lstlisting}

\subsubsection{acc.py} \label{BSSacc}
\begin{lstlisting}[language=Python, caption=acc.py Node]
##
# HAW Hamburg WiSe 2022/23
#
# Fahrrad-Datenlogger Projekt im Studienfach BMT6 Sensorik - Gruppe 5
# bei Prof. Dr. Rasmus Rettig
#
# Erstellt durch:
# Helmer Luis Barcos Paso
##

import uuid
import board
import rospy
import adafruit_lsm303_accel
import adafruit_lsm303dlh_mag

from adafruit_lsm303_accel import Mode, Range, Rate
from adafruit_lsm303dlh_mag import MAGRATE_3_0, MAGGAIN_1_3
from typing import Union
from dataclasses import dataclass
from bssmessage.msg import BSSACCPayload

@dataclass
class AccelerometerData:
    Ax: float = 0.0
    """ Beschleunigung in x in m/s^2 """
    Ay: float = 0.0
    """ Beschleunigung in y in m/s^2 """
    Az: float = 0.0
    """ Beschleunigung in z in m/s^2 """


@dataclass
class MagnetometerData:
    Mx: float = 0.0
    """ Magnetfeld in x in uT (micro Tesla) """
    My: float = 0.0
    """ Magnetfeld in y in uT (micro Tesla) """
    Mz: float = 0.0
    """ Magnetfeld in z in uT (micro Tesla) """


class Accelerometer:
    name = "LSM303"
    sensor = None
    didStart = False
    nodeName = ""

    def __init__(self, nodeName=""):
        self.nodeName = nodeName
        try:
            i2c = board.I2C()
            self.sensor = adafruit_lsm303_accel.LSM303_Accel(i2c)
            self.sensor.mode = Mode.MODE_HIGH_RESOLUTION
            # https://www.digikey.de/en/articles/what-you-need-to-know-to-choose-an-accelerometer
            self.sensor.range = Range.RANGE_8G
            self.sensor.data_rate = Rate.RATE_25_HZ
            self.didStart = True
        except Exception as err:
            self.didStart = False
            rospy.logerr('{} {} Exception: {}'.format(
                self.nodeName, self.name,  err))

    def didStart(self):
        return self.didStart

    def getData(self) -> Union[AccelerometerData, None]:
        if (self.didStart == False):
            rospy.logerr('{} {} I2C not configured'.format(
                self.nodeName, self.name))

        else:
            current = self.sensor.acceleration
            return AccelerometerData(current[0], current[1], current[2])


class Magnetometer:
    name = "LSM303DLH"
    sensor = None
    didStart = False
    nodeName = ""

    def __init__(self, nodeName=""):
        self.nodeName = nodeName
        try:
            i2c = board.I2C()
            self.sensor = adafruit_lsm303dlh_mag.LSM303DLH_Mag(i2c)
            self.sensor.mag_rate = MAGRATE_3_0  # 3Hz
            self.sensor.mag_gain = MAGGAIN_1_3
            self.didStart = True
        except Exception as err:
            self.didStart = False
            rospy.logerr('{} {} Exception: {}'.format(
                self.nodeName, self.name,  err))

    def didStart(self):
        return self.didStart

    def getData(self) -> Union[MagnetometerData, None]:
        if (self.didStart == False):
            rospy.logerr('{} {} I2C not configured'.format(
                self.nodeName, self.name))
        else:
            current = self.sensor.magnetic
            return MagnetometerData(current[0], current[1], current[2])


nodeName = "bsssensorsacc"
printNodeName = "[{}]".format(nodeName)
topicName = "bssdata/acc"

accel = Accelerometer(nodeName=nodeName)


def mainNode():
    # use a bigger queue_size than the rospy.Rate in order to prevent data loss
    pub = rospy.Publisher(topicName, BSSACCPayload, queue_size=200)
    rospy.init_node(nodeName, anonymous=True)
    rospy.loginfo("{} Did start successfully".format(printNodeName))

    # publishes at a rate of 25 messages per second
    rate = rospy.Rate(25)  # 25hz

    while not rospy.is_shutdown():

        msg = BSSACCPayload()

        msg.id = uuid.uuid4().hex
        msg.timestamp = rospy.get_rostime()
        aData = accel.getData()

        if aData:
            msg.Ax = aData.Ax
            msg.Ay = aData.Ay
            msg.Az = aData.Az

        rospy.loginfo(
            "{} BSSACCPayload will be published".format(printNodeName))
        rospy.loginfo("{} BSSACCPayload id={} time={}".format(
            printNodeName, msg.id, msg.timestamp))
        rospy.loginfo(
            "{} BSSACCPayload id={} published successfully\n".format(printNodeName, msg.id))

        pub.publish(msg)
        rate.sleep()


if __name__ == '__main__':
    try:
        mainNode()
    except rospy.ROSInterruptException:
        pass
\end{lstlisting}

\subsection{BSS actuators nodes} \label{BSSactuators}
\subsubsection{buzzer.py} \label{BSSbuzzer}
\begin{lstlisting}[language=Python, caption=buzzer.py Node]
##
# HAW Hamburg WiSe 2022/23
#
# Fahrrad-Datenlogger Projekt im Studienfach BMT6 Sensorik - Gruppe 5
# bei Prof. Dr. Rasmus Rettig
#
# Erstellt durch:
# Dennis Hofmann
##

import rospy
import math
from time import sleep
from typing import Union
from threading import Thread, Event
from gpiozero import TonalBuzzer
from gpiozero.tones import Tone
from dataclasses import dataclass
from bssmessage.msg import BSSBuzzerPayload
from bssmessage.msg import BSSActuatorsPayload

MAX_FREQ = 880.0
MIN_FREQ = 220.0
DEFAULT_GPIO_PORT = 22


@dataclass
class MelodyTone:
    duration: int = 0
    note: str = ""


class Buzzer():
    tonalBuzzer = TonalBuzzer(DEFAULT_GPIO_PORT)
    nodeName: str = ""
    currentIntensity = 0

    isBeeping = False

    thread: Union[Thread, None] = None
    stopEvent = Event()

    def __init__(self, nodeName: str):
        self.nodeName = nodeName

        # Start the beep function in the background using a thread
        self.thread = Thread(target=self.watchIntensity)
        self.thread.start()
        self.tonalBuzzer.play(MAX_FREQ - 200)
        sleep(0.3)
        self.tonalBuzzer.stop()

    def watchIntensity(self):
        while True:
            rep = self.calcRepetitionInterval()
            if self.currentIntensity > 0:
                self.tonalBuzzer.play(MAX_FREQ -200)
                self.isBeeping = True
                sleep(0.1)
                self.tonalBuzzer.stop()
            else:
                self.tonalBuzzer.stop()
            sleep(rep)

    def setIntensity(self, intensity: int):
        self.currentIntensity = intensity

    def stopBeep(self):
        self.currentIntensity = 0
        self.stopEvent.set()
        self.thread.join()
        self.tonalBuzzer.stop()

    def calcRepetitionInterval(self):
        # If intensity is 100, go sleep 0.1s then reproduce 10 beeps each second or 600bpm
        if self.currentIntensity >= 100:
            return 0.1
        # If intensity is o then go sleep 5secs
        elif self.currentIntensity <= 0:
            return 5
        else:
            return 5 - (5 * (1 - math.exp(-self.currentIntensity / 25)))

    def playMelody(self, melody: str, frequency: float, duration: float):
        try:
            if not melody:
                freq = frequency

                if frequency >= MAX_FREQ:
                    rospy.logwarn("{} BSSBuzzerPayload frequency={} too high. Adjusting to ${}".format(
                        self.nodeName, frequency, MAX_FREQ))
                    freq = MAX_FREQ

                if frequency <= MIN_FREQ:
                    rospy.logwarn("{} BSSBuzzerPayload frequency={} too low. Adjusting to ${}".format(
                        self.nodeName, frequency, MIN_FREQ))
                    freq = MIN_FREQ

                self.tonalBuzzer.play(Tone(freq))
                rospy.sleep(duration)
                self.tonalBuzzer.stop()
            else:
                rospy.logwerr("{} BSSBuzzerPayload melody={} not supported".format(
                    self.nodeName, melody))

        except Exception as e:
            rospy.logerr(
                "{} BSSBuzzerPayload Exception :: {}".format(self.nodeName, e))


# melody = [
#     MelodyTone(note="0",duration=4),
#     MelodyTone(note="E4",duration=8),
#     MelodyTone(note="E4",duration=8),
#     MelodyTone(note="A3",duration=4),
#     MelodyTone(note="E4",duration=4),
#     MelodyTone(note="200",duration=4),
#     MelodyTone(note="B3",duration=4),
#     MelodyTone(note="C4",duration=4)]

# for note in melody:
#     try:
#         pasiveBuzzer.play(note.note)
#         rospy.sleep(note.duration)
#     except Exception as e:
#         rospy.logerr("{} BSSBuzzerPayload Exception :: {}".format(printNodeName, e))
#         continue

# Other Melody
# t = 0
# notes = [262, 294, 330, 262, 262, 294, 330, 262, 330, 349, 392, 330, 349, 392, 392,
#          440, 392, 349, 330, 262, 392, 440, 392, 349, 330, 262, 262, 196, 262, 262, 196, 262]
# duration = [2, 0.1, 2, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 1, 0.5, 0.5, 1, 0.25, 0.25,
#             0.25, 0.25, 0.5, 0.5, 0.25, 0.25, 0.25, 0.25, 0.5, 0.5, 0.5, 0.5, 1, 0.5, 0.5, 1]
# for n in notes:
#     pasiveBuzzer.play(n)
#     # buzz(n, duration[t])
#     rospy.sleep(duration[t] * 0.1)
#     t += 1

# spin() simply keeps python from exiting until this node is stopped


nodeName = "bssactuatorsbuzzer"
printNodeName = "[{}]".format(nodeName)
topicName = "bssactuators/buzzer"
defTopicName = "bssactuators/default"

pasiveBuzzer = Buzzer(printNodeName)


def defCallback(data: BSSActuatorsPayload):
    rospy.loginfo("{} BSSActuatorsPayload arrived triggeredBy={} type={} intensity={}".format(
        printNodeName, data.triggeredBy, data.type, data.intensity))
    pasiveBuzzer.setIntensity(data.intensity)


def callback(data: BSSBuzzerPayload):
    rospy.loginfo("{} BSSBuzzerPayload arrived id={} time={} frequency={}".format(
        printNodeName, data.id, data.timestamp, data.frequency))
    pasiveBuzzer.playMelody(
        melody=data.melody, frequency=data.frequency, duration=data.duration)


def mainListener():

    rospy.init_node(nodeName, anonymous=True)
    rospy.loginfo("{} Did start successfully".format(printNodeName))

    rospy.Subscriber(defTopicName, BSSActuatorsPayload, defCallback)
    rospy.Subscriber(topicName, BSSBuzzerPayload, callback)

    rospy.spin()


if __name__ == '__main__':
    try:
        mainListener()
    except rospy.ROSInterruptException:
        pass
\end{lstlisting}

\subsubsection{rgbled.py} \label{BSSled}
\begin{lstlisting}[language=Python, caption=rgbled.py Node]
##
# HAW Hamburg WiSe 2022/23
#
# Fahrrad-Datenlogger Projekt im Studienfach BMT6 Sensorik - Gruppe 5
# bei Prof. Dr. Rasmus Rettig
#
# Erstellt durch:
# Helmer Luis Barcos Paso
##

import rospy
from bssmessage.msg import BSSRGBLedPayload, BSSActuatorsPayload, BSSGNSSPayload
rom gpiozero import RGBLED
from colorzero import Color

DEFAULT_RED_GPIO_PORT = 13
DEFAULT_GREEN_GPIO_PORT = 19
DEFAULT_BLUE_GPIO_PORT = 26
MAX_COLOR_CHANGE_TIMEOUT = 5


class RGBLed():
    color = Color('green')
    led = RGBLED(DEFAULT_RED_GPIO_PORT, DEFAULT_GREEN_GPIO_PORT,
                 DEFAULT_BLUE_GPIO_PORT)

    def __init__(self, nodeName: str) -> None:
        self.printNodeName = nodeName
        self.setIsMoving(4)
        rospy.sleep(3)
        self.setIsMoving(0)
        self.led.color = self.color

    def setIsMoving(self, speed: float):
        isMoving: bool = False

        # Needed minimun offset for preventing False-Positives speeds
        if speed > 2:
            isMoving = True

        if isMoving:
            self.led.blink(on_time=0.1, off_time=0.1, on_color=self.color)
        else:
            self.led.color = self.color

    def handleIntensity(self, intensity:float):

        if intensity >=40 and intensity< 70:
            self.color = Color("yellow")
            self.led.color = self.color
            return

        if intensity >= 70:
            self.color = Color("red")
            self.led.color = self.color
            return
        else:
            self.color = Color("green")
            self.led.color = self.color
            return
  


    def handleCustomState(self, data: BSSRGBLedPayload):
        changeColor = "green"

        try:
            if not data.state:

                # Change the color if color present
                if len(data.color) != 0:
                    changeColor = data.color

                # Change the color if rgb present
                if data.red or data.green or data.blue:
                    someColor = Color.from_rgb(
                        r=data.red, g=data.green, b=data.blue)
                    if someColor:
                        changeColor = someColor

                self.led.color = Color(changeColor)
                rospy.sleep(MAX_COLOR_CHANGE_TIMEOUT)

            else:
                # state triggered by the system
                # One of "RUNNING", "PARKED", "ALARM", "INTERNAL_ERROR"
                changeColor = "green"
                if data.state == "RUNNING":
                    changeColor = "green"
                elif data.state == "PARKED":
                    changeColor = "yellow"
                elif data.state == "ALARM":
                    changeColor = "red"
                elif data.state == "INTERNAL_ERROR":
                    changeColor = "red"
                else:
                    changeColor = "green"

                self.led.color = Color(changeColor)

        except Exception as e:
            rospy.logerr(
                "{} BSSRGBLedPayload Exception :: {}".format(self.printNodeName, e))


nodeName = "bssactuatorsrgbled"
printNodeName = "[{}]".format(nodeName)
topicName = "bssactuators/rgbled"
defTopicName = "bssactuators/default"
gnssTopicName = "bssdata/gnss"

rgbLED = RGBLed(nodeName=printNodeName)


def updateGNSSData(data: BSSGNSSPayload):
    rospy.loginfo("{} updateGNSSData course={} lat={} long={} speed={}".format(
        printNodeName, data.course, data.latitude, data.longitude, data.speed))
    rgbLED.setIsMoving(data.speed)


def defCallback(data: BSSActuatorsPayload):
    rospy.loginfo("{} BSSActuatorsPayload arrived triggeredBy={} type={} intensity={}".format(
        printNodeName, data.triggeredBy, data.type, data.intensity))
    rgbLED.handleIntensity(intensity=data.intensity)


def callback(data: BSSRGBLedPayload):
    rospy.loginfo("{} BSSRGBLedPayload arrived id={} time={} r={} g={} b={} state={} color={}".format(
        printNodeName, data.id, data.timestamp, data.red, data.green, data.blue, data.state, data.color))
    rgbLED.handleCustomState(data=data)


def mainListener():

    rospy.init_node(nodeName, anonymous=True)
    rospy.loginfo("{} Did start successfully".format(printNodeName))

    rospy.Subscriber(defTopicName, BSSActuatorsPayload, defCallback)
    rospy.Subscriber(topicName, BSSRGBLedPayload, callback)
    rospy.Subscriber(gnssTopicName, BSSGNSSPayload, updateGNSSData)

    rospy.spin()


rospy.on_shutdown(rgbLED.led.off)

if __name__ == '__main__':
    try:
        mainListener()
    except rospy.ROSInterruptException:
        pass
\end{lstlisting}

\subsection{BSS http nodes} \label{BSShttp}
\subsubsection{eddy.py} \label{BSSeddy}
\begin{lstlisting}[language=Python, caption=eddy.py Node]
##
# HAW Hamburg WiSe 2022/23
#
# Fahrrad-Datenlogger Projekt im Studienfach BMT6 Sensorik - Gruppe 5
# bei Prof. Dr. Rasmus Rettig
#
# Erstellt durch:
# Helmer Luis Barcos Paso
##

import json
import rospy
import requests
import concurrent.futures
from typing import TypeVar, Generic, Union, Any, List, Dict
from bssmessage.msg import BSSNetConn, BSSGNSSPayload, BSSEddyPOSTPayload, BSSEddyGETPayload
from typing import Union, List, Any, Dict
from bssmessage.msg import BSSWayPoint, BSSLatLong
from geographiclib.geodesic import Geodesic
import APICommunication
import GeoReference, Geometry, Properties

T = TypeVar("T")


class APICommunication(Generic[T]):
    apiKey = ""
    apiSecret = ""

    # defaltAccept = "text/plain"
    defaultContentType = "application/geo+json"

    def __init__(self, apiKey: str, apiSecret: str = ""):
        self.apiKey = apiKey
        self.apiSecret = apiSecret

    def printValues(self):
        rospy.logwarn("[APICommunication]:: API Key = " + self.apiKey)
        rospy.logwarn("[APICommunication]:: API Secret = " + self.apiSecret)

    def get(self, url: str) -> Union[Dict[str, Any], None]:
        headers = self.getHeaders()
        response = requests.get(url, headers=headers)
        if response.status_code == 200 or response.status_code == 201:
            data = response.json()
            rospy.loginfo("[APICommunication]:: Method: GET  | Success")
            return data
        else:
            rospy.logerr(
                "[APICommunication]:: Method: GET  | Error: " + response.reason)
            return None

    def post(self, url: str, payload) -> str:
        headers = self.getHeaders()
        rospy.loginfo(
            "[APICommunication]:: Method: POST | INFO: posting to url " + url)
        # rospy.loginfo(json.dumps(payload, indent=4))
        # rospy.loginfo("[APICommunication]:: posting to url " + payload)

        response = requests.post(url=url, json=payload, headers=headers)
        return self.handleResponse(response=response)

    def postInParallel(self, url: str, payloads) -> List[str]:
        ids = []
        headers = self.getHeaders()
        with concurrent.futures.ThreadPoolExecutor() as executor:
            results = [executor.submit(
                requests.post, url, json=payload, headers=headers) for payload in payloads]
            for f in concurrent.futures.as_completed(results):
                response = f.result()
                localId = self.handleResponse(response=response)
                if len(localId):
                    ids.append(localId)

        return ids

    def handleResponse(self, response: requests.Response) -> str:
        id = ""
        if response.status_code == 200 or response.status_code == 201:
            response_header = dict(response.headers)
            # rospy.loginfo(json.dumps(response_header, indent=4))
            location = response_header['Location']
            object_id = location.split("/")[-1]
            id = object_id
            rospy.loginfo(
                "[APICommunication]:: Method: POST | Success: data sent to the server")
            rospy.loginfo(
                "[APICommunication]:: Method: POST | Success: created object_id " + object_id)
        else:
            rospy.logerr(
                "[APICommunication]:: Method: POST | Error: while sending data to the server")
            rospy.logerr("[APICommunication]:: Error: " + response.reason)

        return id

    def getHeaders(self):
        headers = {
            "Content-Type": self.defaultContentType,
            "apiKey": self.apiKey
        }

        return headers

@dataclass
class Properties:
    createdAt: str = ""
    createdBy: str = ""
    type: str = ""
    group: str = "",
    users: str = "",
    deviceId: str = ""


@dataclass
class Geometry:
    type: str = ""
    latitude: float = 0.0
    longitude: float = 0.0


@dataclass
class GeoReference:
    id: str = ""
    type: str = ""
    properties: Properties = Properties()
    geometry: Geometry = Geometry()

class EddyServer:
    collection_id = "traffic_signs"
    server_url = "https://eddy01.comloc.net/oaf/collections/"
    conn = APICommunication[GeoReference]("Hier API-Key")
    group = ""
    hasInternet = False
    currentCourse = 0.0
    currentLat = 0.0
    currentLong = 0.0
    currentSpeed = 0.0
    currentWayPoints: List[BSSWayPoint] = []

    def __init__(self, group: int):
        self.conn.printValues()
        self.group = str(group)

    def getURL(self, itemId=""):
        base = self.server_url + self.collection_id + "/items"
        if len(itemId) > 0:
            base = base + "/" + itemId

        return base + "?apiKey=" + self.conn.apiKey + "&createdBy=haw-team" + self.group

    def getGeoReferenceById(self, id: str) -> Union[GeoReference, None]:
        url = self.getURL(itemId=id)
        ref = self.conn.get(url)

        if ref != None:
            properties = self.getProperties(ref["properties"])
            geometry = self.getGeometry(ref["geometry"])
            return GeoReference(id=ref["id"], type=ref["type"], properties=properties, geometry=geometry)
        else:
            return None

    def storeGeoReferences(self, type: str, points: List[BSSWayPoint], deviceId: str) -> List[str]:
        payloads = []

        for point in points:
            payloads.append({
                "type": "Feature",
                "geometry": {"type": "Point", "coordinates": [point.latitude, point.longitude]},
                "properties": {
                    "type": type,
                    "group": self.group,
                    "users": "haw-hamburg",
                    "deviceId": deviceId,
                }
            })

        url = self.getURL()
        return self.conn.postInParallel(url=url, payloads=payloads)

    def getGeometry(self, raw: Dict[str, Any]) -> Geometry:
        type = raw.get("type")
        coordinates = raw.get("coordinates")
        return Geometry(type=type, latitude=coordinates[0], longitude=coordinates[1])

    def getProperties(self, raw: Dict[str, Any]) -> Properties:
        createdBy = raw.get("createdBy")
        createdAt = raw.get("createdAt")
        type = raw.get("type")
        group = raw.get("group")
        users = raw.get("users")
        deviceId = raw.get("deviceId")

        return Properties(
            createdAt=createdAt,
            createdBy=createdBy,
            type=type,
            group=group,
            users=users,
            deviceId=deviceId
        )

    # fetchNaerestPoints fetch the important points inside a given box.
    # its keep the local eddy server object up to date with information
    # about the found points in the remote server
    def fetchNaerestPoints(self, box:  List[BSSLatLong]):
        foundWayPoints = []

        try:
            limit = "&limit=" + str(1000)
            sw = str(box[0].latitude) + "%2C" + str(box[0].latitude)
            ne = str(box[0].latitude) + "%2C" + str(box[0].latitude)
            bbox = "&bbox=" + sw + "%2C" + ne

            url = self.getURL() + limit + bbox
            jsonBody = self.conn.get(url)

            if len(jsonBody):
                numberMatched = jsonBody.get("numberMatched")
                numberReturned = jsonBody.get("numberReturned")
                if numberReturned:

                    rospy.loginfo(
                        "[EddyServer]:: fetchNaerestPoints=" + str(numberReturned) + " of numberMatched=" + str(numberMatched))
                    # rospy.loginfo(json.dumps(jsonBody, indent=4))
                    points: List[Dict[str, Any]] = jsonBody.get("features")
                    for point in points:
                        geometry = self.getGeometry(point.get("geometry"))
                        properties = self.getProperties(
                            point.get("properties"))
                        foundWayPoint = BSSWayPoint(
                            type=properties.type, latitude=geometry.latitude, longitude=geometry.longitude)
                        foundWayPoints.append(foundWayPoint)

                    self.currentWayPoints = foundWayPoints
                else:
                    rospy.loginfo(
                        '[EddyServer]:: fetchNaerestPoints= {}'.format(numberReturned))
        except Exception as err:
            rospy.logerr('[EddyServer]:: Exception: {}'.format(err))

    def getBoundingBox(self, center: BSSLatLong, distanceFromCenter: float) -> List[BSSLatLong]:
        neAzimuth = 45
        swAzimuth = 225

        gne = Geodesic.WGS84.Direct(
            center.latitude, center.longitude, neAzimuth, distanceFromCenter)

        gsw = Geodesic.WGS84.Direct(
            center.latitude, center.longitude, swAzimuth, distanceFromCenter)

        pointSW = BSSLatLong(latitude=gsw['lat2'], longitude=gsw['lon2'])
        pointNe = BSSLatLong(latitude=gne['lat2'], longitude=gne['lon2'])

        return [pointSW, pointNe]

    def getCurrentCenter(self) -> BSSLatLong:
        return BSSLatLong(latitude=self.currentLat, longitude=self.currentLong)

    # getInnerPolygon create the boundingbox small [3m from center point] arround the current location.
    # def getInnerPolygon(self, currentLat: float, currentLong: float, course: float) -> List[BSSLatLong]:
    def getInnerPolygon(self):

        bbox = self.getBoundingBox(
            center=self.getCurrentCenter(), distanceFromCenter=3)

        # TODO v2 get the boundingbox with a custom course
        # point = BSSLatLong()
        # point.latitude = 0.0
        # point.longitude = 0.0

        # innerPolygon = []
        # innerPolygon.append(point)
        # return innerPolygon
        return bbox

    # getInnerPolygon create the boundingbox small [10m from center point] arround the current location.
    # def getOuterPolygon(self, currentLat: float, currentLong: float, course: float) -> List[BSSLatLong]:
    def getOuterPolygon(self):
        bbox = self.getBoundingBox(
            center=self.getCurrentCenter(), distanceFromCenter=10)

        # TODO v2 get the boundingbox with a custom course
        # point = BSSLatLong()
        # point.latitude = 0.0
        # point.longitude = 0.0

        # outerPolygon = []
        # outerPolygon.append(point)
        # return outerPolygon
        return bbox

nodeName = "bsshttpeddy"
printNodeName = "[{}]".format(nodeName)
netTopicName = "bsscore/net"
gnssTopicName = "bssdata/gnss"
eddyPostTopicName = "bsshttp/eddy/post"
eddyGetTopicName = "bsshttp/eddy/get"

# gruppe 5 im Fach BMT6-Sensorik
# WiSe 2022/23
# deviceId="prototype-1.0"
eddyServer = EddyServer(group=5)


def updateNetConn(data: BSSNetConn):
    if eddyServer.hasInternet != data.isConnected:
        eddyServer.hasInternet = data.isConnected
        rospy.logwarn("{} updateNetConn isConnected={}".format(
        printNodeName, data.isConnected))


def updateGNSSData(data: BSSGNSSPayload):
    rospy.loginfo("{} updateGNSSData course={} lat={} long={} speed={}".format(
        printNodeName, data.course, data.latitude, data.longitude, data.speed))
    eddyServer.currentLat = data.latitude
    eddyServer.currentLong = data.longitude
    eddyServer.currentSpeed = data.speed
    eddyServer.currentCourse = data.course


def handleEddyPOST(data: BSSEddyPOSTPayload):
    if eddyServer.hasInternet:
        rospy.loginfo("{} handleEddyPOST type={} #of_wayPoints={} deviceId={}".format(
            printNodeName, data.type, len(data.wayPoints), data.deviceId))
        ids = eddyServer.storeGeoReferences(
            type=data.type, points=data.wayPoints, deviceId=data.deviceId)
        rospy.loginfo("{} handleEddyPOST success. created wayPoints={}".format(
            printNodeName, len(ids)))
    else:
        rospy.logerr("{} handleEddyPOST type={} #of_wayPoints={} deviceId={} not posible. Verify your network connection".format(
            printNodeName, data.type, len(data.wayPoints), data.deviceId))


def mainNode():

    rospy.init_node(nodeName, anonymous=True)
    rospy.loginfo("{} Did start successfully".format(printNodeName))

    rospy.Subscriber(netTopicName, BSSNetConn, updateNetConn)
    rospy.Subscriber(gnssTopicName, BSSGNSSPayload, updateGNSSData)
    rospy.Subscriber(eddyPostTopicName, BSSEddyPOSTPayload, handleEddyPOST)

    pub = rospy.Publisher(eddyGetTopicName, BSSEddyGETPayload, queue_size=10)

    rospy.init_node(nodeName, anonymous=True)
    rospy.loginfo("{} Did start successfully".format(printNodeName))

    # publishes at a rate of 1 message per 2 seconds
    rate = rospy.Rate(0.5)  # 0.5hz

    while not rospy.is_shutdown():

        if eddyServer.hasInternet:
            msg = BSSEddyGETPayload()
            msg.direction = eddyServer.currentCourse
            # speed 2 prevents positive negatives
            msg.isMoving = eddyServer.currentSpeed > 2

            msg.innerPolygon = eddyServer.getInnerPolygon()
            msg.outerPolygon = eddyServer.getOuterPolygon()

            box = msg.innerPolygon
            if msg.isMoving:
                box = msg.outerPolygon

            eddyServer.fetchNaerestPoints(box)

            msg.wayPoints = eddyServer.currentWayPoints
            pub.publish(msg)
            rospy.loginfo(
                "{} Successfully published the current radar information".format(printNodeName))
        else:
            rospy.logerr(
                "{} the current radar information wasnt published. Verify your network connection".format(printNodeName))

        rate.sleep()


if __name__ == '__main__':
    try:
        mainNode()
    except rospy.ROSInterruptException:
        pass

\end{lstlisting}

\subsection{BSS processing nodes} \label{BSSprocessing}
\subsubsection{processing.py} \label{BSSpro}
\begin{lstlisting}[language=Python, caption=eddy.py Node]
##
# HAW Hamburg WiSe 2022/23
#
# Fahrrad-Datenlogger Projekt im Studienfach BMT6 Sensorik - Gruppe 5
# bei Prof. Dr. Rasmus Rettig
#
# Erstellt durch:
# Dennis Hofmann & Helmer Luis Barcos Paso
##
import rospy
import math
import pandas as pd
import numpy as np
from statistics import stdev
from collections import deque
import uuid
import socket
import rospy

np.random.BitGenerator = np.random.bit_generator.BitGenerator
from bssmessage.msg import BSSNetConn, BSSACCPayload, BSSEddyPOSTPayload, BSSActuatorsPayload


nodeName = "bssproccessinproccessing"
printNodeName = "[{}]".format(nodeName)
netTopicName = "bsscore/net"
accTopicName = "bssdata/acc"
eddyPostTopicName = "bsshttp/eddy/post"
defActuatorsTopicName = "bssactuators/default"

QUEUE_MAX_SIZE = 50
class DataProcessor:
    hasInternet = False
    actuatorsPub = None
    eddyPub = None
    buffer = []

    smallest_std = 0.0


    queue = deque(maxlen=QUEUE_MAX_SIZE)
    std_queue = deque(maxlen=QUEUE_MAX_SIZE)

    def __init__(self) -> None:
        pass

    # moving algorithm
    def enqueue(self, data: BSSACCPayload):
        self.queue.append(data)
        if len(self.queue) == QUEUE_MAX_SIZE:
            self.procces(math.ceil(QUEUE_MAX_SIZE/ 2))

    
    def procces(self, index):
        (std, category) = self.calc_std()
        # element = self.queue[index]
        msg = BSSActuatorsPayload()
        msg.intensity = self.get_intensity(category)
        msg.triggeredBy = "processing"
        msg.type = str(category)
        self.actuatorsPub.publish(msg)

    
    def calc_std(self):
        
        # Extract the values of the "az" property from each element in the queue
        # az_values = [element["Az"] for element in self.queue]
        az_values = []
        for element in list(self.queue):
            az_values.append(element.Az)


        local_std = stdev(az_values)
        self.std_queue.append(local_std)
        category  = 0 # unclissified



        if len(self.std_queue) == QUEUE_MAX_SIZE:
            # Use numpy.histogram() to create 5 categories
            hist, bins = np.histogram(self.std_queue, bins=5)
            category = np.digitize(local_std, bins)


        if local_std == 0:
            self.smallest_std = local_std
        elif local_std < self.smallest_std:
            self.smallest_std = local_std
        
        return (local_std, category)
    
    def get_intensity(self, category:int):
        if category == 1:
            return 0
        elif category <=2:
            return category * 15
        elif category <= 4:
            return category *15
        else:
            return max(category * 15, 100)
            
# imuTopicName = "bssdata/imu"
# gnssTopicName = "bssdata/gnss"
# ussTopicName = "bssdata/uss"

processor = DataProcessor()


def updateNetConn(data: BSSNetConn):
    if processor.hasInternet != data.isConnected:
        processor.hasInternet = data.isConnected
        rospy.logwarn("{} updateNetConn isConnected={}".format(
        printNodeName, data.isConnected))

def handleAcc(data: BSSACCPayload):
    processor.enqueue(data)

def mainNode():

    rospy.init_node(nodeName, anonymous=True)
    rospy.loginfo("{} Did start successfully".format(printNodeName))

    processor.actuatorsPub = rospy.Publisher(defActuatorsTopicName, BSSActuatorsPayload, queue_size=20)
    processor.eddyPub = rospy.Publisher(eddyPostTopicName, BSSEddyPOSTPayload, queue_size=20)

    rospy.Subscriber(netTopicName, BSSNetConn, updateNetConn)
    rospy.Subscriber(accTopicName, BSSACCPayload, handleAcc)

    rospy.spin()


if __name__ == '__main__':
    try:
        mainNode()
    except rospy.ROSInterruptException:
        pass
        
\end{lstlisting}

\subsubsection{radar.py} \label{BSSradar}
\begin{lstlisting}[language=Python, caption=radar.py Node]
##
# HAW Hamburg WiSe 2022/23
#
# Fahrrad-Datenlogger Projekt im Studienfach BMT6 Sensorik - Gruppe 5
# bei Prof. Dr. Rasmus Rettig
#
# Erstellt durch:
# Dennis Hofmann & Helmer Luis Barcos Paso
##

import rospy
from dataclasses import dataclass
from typing import List, Any, Union
import geographiclib.geodesic as geo
from bssmessage.msg import BSSWayPoint, BSSEddyGETPayload
from bssmessage.msg import BSSEddyGETPayload, BSSGNSSPayload, BSSActuatorsPayload


nodeName = "bssproccessingradar"
printNodeName = "[{}]".format(nodeName)

gnssTopicName = "bssdata/gnss"
eddyGetTopicName = "bsshttp/eddy/get"
defActuatorsTopicName = "bssactuators/default"

radar = Radar()

def updateGNSSData(data: BSSGNSSPayload):
    rospy.loginfo("{} updateGNSSData course={} lat={} long={} speed={}".format(
        printNodeName, data.course, data.latitude, data.longitude, data.speed))
    radar.currentLat = data.latitude
    radar.currentLong = data.longitude
    radar.currentSpeed = data.speed
    radar.currentCourse = data.course

def handlerEddyGET(payload: BSSEddyGETPayload):
    rospy.loginfo("{} handlerEddyGET".format(printNodeName))
    radar.update(payload)

def notifyActuators(pub, topic: str, intensity: int, triggeredBy: str, type: str):
    msg = BSSActuatorsPayload()
    msg.intensity = intensity
    msg.triggeredBy = triggeredBy
    msg.type = type

    rospy.loginfo(
        "{} BSSActuatorsPayload will be published to {}".format(printNodeName, topic))
    pub.publish(msg)
    rospy.loginfo(
        "{} BSSActuatorsPayload published successfully\n".format(printNodeName, msg.id))

def mainNode():
    rospy.init_node(nodeName, anonymous=True)
    rospy.loginfo("{} Did start successfully".format(printNodeName))

    rospy.Subscriber(gnssTopicName, BSSGNSSPayload, updateGNSSData)
    rospy.Subscriber(eddyGetTopicName, BSSEddyGETPayload, handlerEddyGET)

    pub = rospy.Publisher(defActuatorsTopicName,
                          BSSActuatorsPayload, queue_size=20)

    radar.registerPublisher(pub)
    radar.registerActuatorCallback(defActuatorsTopicName, notifyActuators)

    rate = rospy.Rate(1)
    while not rospy.is_shutdown():
        radar.findNearestPoint()
        radar.notifyActuators()
        rate.sleep()

if __name__ == '__main__':
    try:
        mainNode()
    except rospy.ROSInterruptException:
        pass
\end{lstlisting}

\section{Messages}
\subsection{BSSACCPayload.msg} \label{ACCPayload}
\begin{lstlisting}[language=Python, caption=BSSACCPayload.msg]
string id
time timestamp

# AccelerometerData in m/s^2
float64 Ax
float64 Ay
float64 Az
\end{lstlisting}

\subsection{BSSActuatorsPayload.msg} \label{actuatorsPayload}
\begin{lstlisting}[language=Python, caption=BSSActuatorsPayload.msg]
string type
string triggeredBy
int32 intensity
\end{lstlisting}

\subsection{BSSBuzzerPayload.msg} \label{buzzerPayload}
\begin{lstlisting}[language=Python, caption=BSSBuzzerPayload.msg]
string id
time timestamp
# Tone to be played
float32 frequency
float32 duration
# One of "START", "ALARM", "NET_CONN", "NET_DISC", "INTERNAL_ERROR"
string melody
\end{lstlisting}

\subsection{BSSEddyGETPayload.msg} \label{eddyGETPayload}
\begin{lstlisting}[language=Python, caption=BSSeddyGETPayload.msg]
bool isMoving
float32 direction

# innerPolygon[0] = Südwest Punkt 
# innerPolygon[1] = Nordost Punkt 
BSSLatLong[] innerPolygon

# outerPolygon[0] = Südwest Punkt 
# outerPolygon[1] = Nordost Punkt 
BSSLatLong[] outerPolygon
BSSWayPoint[] wayPoints 
\end{lstlisting}

\subsection{BSSEddyPOSTPayload.msg} \label{eddyPOSTPayload}
\begin{lstlisting}[language=Python, caption=BSSEddyPOSTPayload.msg]
string type
string deviceId
BSSWayPoint[] wayPoints
\end{lstlisting}

\subsection{BSSGNSSPayload.msg} \label{GNSSPayload}
\begin{lstlisting}[language=Python, caption=BSSGNSSPayload.msg]
string id
time timestamp
bool hasValue
float64 latitude
float64 longitude
# Speed over ground in knots (000.0 ~ 999.9)
float32 speed
# Course over ground in degrees (000.0 ~ 359.9)
float32 course
\end{lstlisting}

\subsection{BSSI2CState.msg} \label{ACCPayload}
\begin{lstlisting}[language=Python, caption=BSSI2CState.msg]
string id
time timestamp
bool isBusActive
uint8 deviceCount
\end{lstlisting}

\subsection{BSSIMUPayload.msg} \label{IMUPayload}
\begin{lstlisting}[language=Python, caption=BSSIMUPayload.msg]
string id
time timestamp

# Pressure (Pa), Temp (°C) and altitude (m)
float32 pressure
float32 temperature
float32 altitude

# GyroscopeData in rad/s
float64 Wx
float64 Wy
float64 Wz

# MagnetometerData in uT (micro Tesla)
float64 Mx
float64 My
float64 Mz

# AccelerometerData in m/s^2
float64 Ax
float64 Ay
float64 Az
\end{lstlisting}

\subsection{BSSLatLong.msg} \label{LatLongPayload}
\begin{lstlisting}[language=Python, caption=BSSLatLong.msg]
float64 latitude
float64 longitude
\end{lstlisting}

\subsection{BSSNetConn.msg} \label{NetConn}
\begin{lstlisting}[language=Python, caption=BSSNetConn.msg]
string id
time timestamp
bool isConnected
\end{lstlisting}

\subsection{BSSPoint.msg} \label{Point}
\begin{lstlisting}[language=Python, caption=BSSPoint.msg]
string id
time timestamp
bool hasValue
float64 latitude
float64 longitude
\end{lstlisting}

\subsection{BSSRGBLEDPayload.msg} \label{RGBLEDPayload}
\begin{lstlisting}[language=Python, caption=BSSRGBLEDPayload.msg]
string id
time timestamp
# Tone to be played
float32 red
float32 green
float32 blue
# the named color
string color
# One of "RUNNING", "PARKED", "ALARM", "INTERNAL_ERROR"
string state
\end{lstlisting}

\subsection{BSSWayPoint.msg} \label{Waypoint}
\begin{lstlisting}[language=Python, caption=BSSWayPoint.msg]
string type
float64 latitude
float64 longitude
\end{lstlisting}
\pagebreak

\section{Docker} \label{kap:DockerFiles}
\subsection{Dockerfile} \label{dockerfile}
\begin{lstlisting}[language=Go, caption=Dockerfile]
FROM ros:noetic

WORKDIR /root/catkin_ws

# Setup enviroment
RUN echo "source /opt/ros/noetic/setup.sh" >> ~/.bashrc
RUN echo "source /root/catkin_ws/devel/setup.bash" >> ~/.bashrc
RUN echo "source /opt/ros/noetic/setup.sh" >> ~/.profile
RUN echo "source /root/catkin_ws/devel/setup.bash" >> ~/.profile

# install ros package
RUN apt-get update && apt-get install -y \
    ros-${ROS_DISTRO}-ros-tutorials \
    ros-${ROS_DISTRO}-common-tutorials && \
    rm -rf /var/lib/apt/lists/*

#RUN apt-get update && apt-get install -y python3.9 python3.9-dev
RUN apt-get update && apt-get install python3-pip git -y

# install packages
RUN apt-get update && apt-get install -y
RUN apt-get install python3-dev python3-rpi.gpio -y

# Standard Python Libraries
RUN pip3 install python-dotenv requests typing RPi.GPIO gpiozero geographiclib numpy pandas
RUN pip3 install --upgrade --force-reinstall adafruit-blinka Adafruit-PlatformDetect


# (10DOF Module) Library for L3GD20H Gyroscope
# https://learn.adafruit.com/adafruit-triple-axis-gyro-breakout/python-circuitpython
# https://github.com/adafruit/Adafruit_CircuitPython_L3GD20
RUN pip3 install adafruit-circuitpython-l3gd20

# (10DOF Module) Library for LSM303DLHC Accelerometer + Magnetfeld Sensor
# https://learn.adafruit.com/lsm303-accelerometer-slash-compass-breakout/python-circuitpython
RUN pip3 install adafruit-circuitpython-lsm303-accel adafruit-circuitpython-lsm303dlh-mag

# (10DOF Module) Library for BMP180 Drucksensor
# https://learn.adafruit.com/bmp085/downloads
# https://www.adafruit.com/product/1603
# https://github.com/adafruit/Adafruit_Python_BMP
RUN pip3 install git+https://github.com/adafruit/Adafruit_Python_BMP

# (GPS Module) Library for Venus638FLPx SparkFun Venus GPS with SMA Connector
# https://www.sparkfun.com/products/retired/11058
# https://www.skytraq.com.tw/AN0018_v3.7.pdf
# http://pabigot.github.io/bsp430/ex_sensors_venus6pps.html
# http://cdn.sparkfun.com/datasheets/Sensors/GPS/Venus/638/doc/Venus638FLPx_DS_v07.pdf
# Binary Messages of SkyTraq Venus 6 GPS Receiver
# http://dlnmh9ip6v2uc.cloudfront.net/datasheets/Sensors/GPS/Venus/638/doc/AN0003_v1.4.19.pdf
RUN pip3 install pynmea2

# Mount all needed UART interfaces
# Bind physical UART0 to Docker UART0 and its symlink serial0
VOLUME /dev/ttyAMA0 /dev/ttyAMA0
VOLUME /dev/serial0 /dev/serial0
# Bind physical I2C-1 to Docker I2C-1. I2C-[1-6] possible
# IC2-[2-6] need activation inside the config.txt
VOLUME /dev/i2c-1

# Copy the devel dir and the .catkin_workspace file. Just needed inside the container
COPY catkin_ws .

# Build the project inside the container
RUN /bin/bash -c '. /opt/ros/noetic/setup.bash; catkin_make -C /root/catkin_ws'

# Lunch all nodes
RUN /bin/bash -c '. /opt/ros/noetic/setup.bash;. devel/setup.sh; rospack find bsslaunch'
CMD /bin/bash -c '. /opt/ros/noetic/setup.bash;. devel/setup.sh; roslaunch --log bsslaunch bss.launch'

# # Execute the roscore
# CMD roscore

# default entryporint for keep on running without getting terminated 
# ENTRYPOINT ["tail", "-f", "/dev/null"]
\end{lstlisting}

\subsection{docker-compose.yaml} \label{dockercompose}
\begin{lstlisting}[language=Python, caption=docker-compose.yaml]
version: '3.7'

services:
  bssrostest:
    privileged: true
    # https://docs.docker.com/compose/profiles/
    profiles: 
      - "test"
    build:
      dockerfile: Dockerfile.test
    image: bss/rostest
    container_name: bssrostest
    restart: on-failure
    working_dir: /bmt6-sensorik-gruppe6
    tty: true
    networks:
      - rosnetwork
    volumes:
      # Volume for persist data after build and other stuff
      - bssrostest-volume:/root/catkin_ws/data
      # Bind local src files to workdir
      - "./catkin_ws/src/:/bmt6-sensorik-gruppe6"
      # Mount all needed UART interfaces
      # Bind physical UART0 to Docker UART0 and its symlink serial0
      - /dev/ttyAMA0:/dev/ttyAMA0
      - /dev/serial0:/dev/serial0
      # Bind physical I2C-1 to Docker I2C-1. I2C-[1-6] possible
      # IC2-[2-6] need activation inside the config.txt
      - /dev/i2c-1:/dev/i2c-1

          
  bssros:
    privileged: true
    # https://docs.docker.com/compose/profiles/
    profiles: 
      - "ros"
    build:
      dockerfile: Dockerfile
    image: bss/ros
    container_name: bssros
    restart: on-failure
    working_dir: /root/catkin_ws
    tty: true
    environment:
      - WRITER_PATH=/root/catkin_ws/data
    networks:
      - rosnetwork
    volumes:
      # Volume for persist data
      - bssros-volume:/root/catkin_ws/data
      # Bind local src files to workdir
      - ./catkin_ws/src/:/root/catkin_ws/src
      # Mount all needed UART interfaces
      # Bind physical UART0 to Docker UART0 and its symlink serial0
      - /dev/ttyAMA0:/dev/ttyAMA0
      - /dev/serial0:/dev/serial0
      # Bind physical I2C-1 to Docker I2C-1. I2C-[1-6] possible
      # IC2-[2-6] need activation inside the config.txt
      - /dev/i2c-1:/dev/i2c-1


networks:
  rosnetwork:
    driver: bridge
    name: rosnetwork

volumes:
  bssrostest-volume:
    name: bssrostest-volume
  bssros-volume:
    name: bssros-volume
\end{lstlisting}